<template>
    <div class="module-options">
        <div @click="toggleOpen" class="option-icon">
            <app-icon icon="ellipsis-v"></app-icon>
        </div>
        <transition name="move-up">
            <div v-if="open" class="option-selection">
                <div class="close">
                    <app-icon @click="toggleOpen" icon="times-circle"></app-icon>
                </div>
                <ul class="options">
                    <li class="option-item" @click="openPopup">
                        <div class="icon">
                            <app-icon icon="trash-alt"></app-icon>
                        </div>
                        <div class="title">Delete Note</div>
                    </li>
                </ul>
            </div>
        </transition>
        <delete-popup :open="isPopUpOpen" @open="closePopup" @confirmAction="performDelete"></delete-popup>
    </div>
</template>

<style lang="css" scoped>
.move-up-enter-active,
.move-up-leave-active {
    transition: all 200ms cubic-bezier(0.4, 0, 0.2, 1);
}
.move-up-enter,
.move-up-leave-to {
    opacity: 0;
    transform: translateY(200px);
}
</style>

<script lang='ts'>
import Component, { mixins } from 'vue-class-component'
import DeletePopup from '@/app/Editor/components/Note/primitives/DeleteNotePopup.vue'
import { ModuleOptionsMixin } from '@/app/Editor/components/mixins/ModuleOptions'
import { Prop } from 'vue-property-decorator'
import { INote } from '@/store/types/notebooks'
import { offlineDB } from '@/offline/db'

@Component({
    components: { DeletePopup },
})
export default class NoteOptions extends mixins(ModuleOptionsMixin) {
    // Props

    @Prop() note!: INote

    // Methods

    performDelete() {
        if (this.note) {
            const { id } = this.note.notebook
            const url = `/notebook/${id}/`
            offlineDB.deleteNote(this.note).then(() => {
                if (this.$route.fullPath !== url) this.$router.push(url)
            })
        }
    }
}
</script>